'use strict';

// ** Dependencies
const EventEmitter = require('events').EventEmitter;
const logger = require('./logging').createLogger('program');

// Program Events
const events = new EventEmitter();

function shutdown() {
    logger.debug('Shutting down program...');
    events.emit('shutdown');
}

// Add process hooks
process.on('SIGINT', function () {
    logger.debug('**** RECEIVED SIGNAL [SIGINT] ****');
    shutdown();
});
process.on('SIGTERM', function () {
    logger.debug('**** RECEIVED SIGNAL [SIGTERM] ****');
    shutdown();
});

// ** Exports
module.exports.on = events.on.bind(events);
module.exports.shutdown = shutdown;